#ifndef _POPULATION_H_
#define _POPULATION_H_

#include <vector>
#include <iostream>
using namespace std;

#include "Individual.h"
#include "Archive.h"
#include "OffspringGenerator.h"

class Archive;

//============================================
//	class Population
//============================================
class Population{
public:
    
	Population();
    
	Individual* getPopulation(int i);
	vector<Individual>& getPopulation(){
		return population;
	}
	void evolve();
	void setPopulation(vector<Individual>& pop){
		population.resize(pop.size());
		for(int i=0;i<pop.size();i++){
			population[i]=pop[i];
		}
	}
	
		
private:
	
	int populationSize;
    vector<Individual> population;	//õ콸
	
	void mutate();//Ѱۤ
	void crossover();//򺵤
	void repair();//ᤷ
	void evaluate();//ɾ
};

#endif //_POPULATION_H_
