#include <vector>
#include <algorithm>
#include <iostream>
using namespace std;
#include "Individual.h"
#include "Parameter.h"

#ifndef _OFFSPRINGGENERATOR_H__
#define _OFFSPRINGGENERATOR_H_

class Individual;

//============================================
//	class OffspringGenerator
//============================================
class OffspringGenerator{
public:
	
	OffspringGenerator(){
		randomGenerator = &RandomGenerator::getInstance();
	 	parameter = &Parameter::getInstance();
		mating.resize(0);
		tmp.resize(2);
		pointer=Parameter::getInstance().getPopulationSize()-1;
	};
	//򺵤ڥꤹ
	virtual void makePairs(vector<Individual>& population) = 0;
    void getChild(vector<Individual>& parents);
	vector<Individual>& getParents();
	Individual& getOneChild(int i){
		return tmp[i];
	}
	
protected:
	int pointer;
	Parameter* parameter;
	RandomGenerator *randomGenerator;
	
	//餫ν¤ؤ줿η
	vector<Individual> mating;
	//PopulationϤ
	vector<Individual> tmp;
	

};


//============================================
//	class NormalCrossover
//============================================

class NormalCrossover : public OffspringGenerator{
public:

    NormalCrossover();
	//򺵥ڥ
	void makePairs(vector<Individual>& population);	

private:

};

#endif //_OFFSPRINGGENERATOR_H_
