#include "Parameter.h"

Parameter::Parameter(){
	numObjective = 2;
	numDesign = 10;
	populationSize = 100;
	designLength = 20;
	geneLength = designLength*numDesign;
	numCrossover = 2;
	maxGeneration = 250;
	mutationRate = 1.0/geneLength;
	crossoverRate = 1.0;
	func = new KUR(numDesign);
	finitial = 0;
}
//Parameter󥹥󥹤֤
Parameter& Parameter::getInstance(){
	static Parameter* para;
	if(para == 0){
		para = new Parameter;
	}
	return *para;
}
